import * as i0 from '@angular/core';
import { input, model, output, ChangeDetectionStrategy, Component } from '@angular/core';

class LibsUiComponentsSwitchComponent {
    // #region PROPERTY
    size = input('default');
    disable = input();
    active = model(false);
    // #region OUTPUT
    outSwitch = output();
    /* FUNCTIONS */
    async handlerClick(event) {
        event.stopPropagation();
        if (this.disable()) {
            return;
        }
        this.setActiveToggle();
        this.outSwitch.emit({
            active: this.active(),
            revert: this.setActiveToggle.bind(this)
        });
    }
    async setActiveToggle() {
        this.active.update(value => value ? false : true);
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: LibsUiComponentsSwitchComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "18.2.13", type: LibsUiComponentsSwitchComponent, isStandalone: true, selector: "libs_ui-components-switch", inputs: { size: { classPropertyName: "size", publicName: "size", isSignal: true, isRequired: false, transformFunction: null }, disable: { classPropertyName: "disable", publicName: "disable", isSignal: true, isRequired: false, transformFunction: null }, active: { classPropertyName: "active", publicName: "active", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { active: "activeChange", outSwitch: "outSwitch" }, ngImport: i0, template: "<div [attr.size]=\"size()\"\n  [class.libs-ui-switch-container]=\"true\"\n  [class.pointer-events-none]=\"disable()\"\n  (click)=\"handlerClick($event)\">\n  <div [attr.size]=\"size()\"\n    [class.libs-ui-switch-bar]=\"true\"\n    [class.libs-ui-switch-bar-active]=\"active()\"\n    [class.libs-ui-disable-background]=\"!active() && disable()\"\n    [class.libs-ui-disable-active-background]=\"active() && disable()\">\n  </div>\n  <div [attr.size]=\"size()\"\n    [class.libs-ui-switch-circle]=\"true\"\n    [class.libs-ui-switch-circle-active]=\"active()\">\n  </div>\n\n</div>\n", styles: [".libs-ui-switch-container{position:relative;cursor:pointer}.libs-ui-switch-container .libs-ui-switch-bar{width:30px;height:16px;border-radius:8px;background-color:#cdd0d6;transition:all .3s;-webkit-transition:all .3s}.libs-ui-switch-container .libs-ui-switch-bar[size=large]{width:45px;height:24px;border-radius:24px}.libs-ui-switch-container .libs-ui-switch-bar.libs-ui-switch-bar-active{background-color:var(--libs-ui-color-default, #226FF5)}.libs-ui-switch-container .libs-ui-switch-circle{height:12px;width:12px;background-color:#fff;border-radius:50%;position:absolute;top:2px;left:2px;cursor:pointer;transition:left .3s;-webkit-transition:left .3s}.libs-ui-switch-container .libs-ui-switch-circle[size=large]{width:20px;height:20px}.libs-ui-switch-container .libs-ui-switch-circle.libs-ui-switch-circle-active{left:16px}.libs-ui-switch-container .libs-ui-switch-circle.libs-ui-switch-circle-active[size=large]{left:23px}.libs-ui-switch-container .libs-ui-disable-background{background-color:#e6e7ea!important}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: LibsUiComponentsSwitchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'libs_ui-components-switch', standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div [attr.size]=\"size()\"\n  [class.libs-ui-switch-container]=\"true\"\n  [class.pointer-events-none]=\"disable()\"\n  (click)=\"handlerClick($event)\">\n  <div [attr.size]=\"size()\"\n    [class.libs-ui-switch-bar]=\"true\"\n    [class.libs-ui-switch-bar-active]=\"active()\"\n    [class.libs-ui-disable-background]=\"!active() && disable()\"\n    [class.libs-ui-disable-active-background]=\"active() && disable()\">\n  </div>\n  <div [attr.size]=\"size()\"\n    [class.libs-ui-switch-circle]=\"true\"\n    [class.libs-ui-switch-circle-active]=\"active()\">\n  </div>\n\n</div>\n", styles: [".libs-ui-switch-container{position:relative;cursor:pointer}.libs-ui-switch-container .libs-ui-switch-bar{width:30px;height:16px;border-radius:8px;background-color:#cdd0d6;transition:all .3s;-webkit-transition:all .3s}.libs-ui-switch-container .libs-ui-switch-bar[size=large]{width:45px;height:24px;border-radius:24px}.libs-ui-switch-container .libs-ui-switch-bar.libs-ui-switch-bar-active{background-color:var(--libs-ui-color-default, #226FF5)}.libs-ui-switch-container .libs-ui-switch-circle{height:12px;width:12px;background-color:#fff;border-radius:50%;position:absolute;top:2px;left:2px;cursor:pointer;transition:left .3s;-webkit-transition:left .3s}.libs-ui-switch-container .libs-ui-switch-circle[size=large]{width:20px;height:20px}.libs-ui-switch-container .libs-ui-switch-circle.libs-ui-switch-circle-active{left:16px}.libs-ui-switch-container .libs-ui-switch-circle.libs-ui-switch-circle-active[size=large]{left:23px}.libs-ui-switch-container .libs-ui-disable-background{background-color:#e6e7ea!important}\n"] }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { LibsUiComponentsSwitchComponent };
//# sourceMappingURL=libs-ui-components-switch.mjs.map
